package com.landray.kmss.sys.attachment.jg;

import java.sql.PreparedStatement;
import java.sql.Connection;
import com.landray.kmss.sys.organization.model.SysOrgElement;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import net.sf.json.JSONObject;
import java.sql.Statement;
import org.springframework.jdbc.support.JdbcUtils;
import java.sql.SQLException;
import java.sql.Timestamp;
import com.landray.kmss.util.SpringBeanUtil;
import javax.sql.DataSource;
import java.util.Date;
import com.landray.kmss.util.UserUtil;
import com.landray.kmss.util.StringUtil;
import javax.servlet.http.HttpServletResponse;
import com.landray.kmss.common.actions.RequestContext;
import org.slf4j.LoggerFactory;
import com.landray.kmss.sys.organization.interfaces.ISysOrgCoreService;
import org.slf4j.Logger;

public class SysAttJGAddtionIsFirstFunction extends AbstractSysAttachmentJGAddtionFunction
{
    private static final Logger logger;
    private ISysOrgCoreService sysOrgCoreService;
    
    static {
        logger = LoggerFactory.getLogger(SysAttJGAddtionIsFirstFunction.class);
    }
    
    public SysAttJGAddtionIsFirstFunction() {
        this.sysOrgCoreService = null;
    }
    
    public void setSysOrgCoreService(final ISysOrgCoreService sysOrgCoreService) {
        this.sysOrgCoreService = sysOrgCoreService;
    }
    
    @Override
    public void execute(final RequestContext request, final HttpServletResponse response) throws Exception {
        String isEdit = "0";
        String editOrgName = "";
        try {
            final String fdId = request.getParameter("fdId");
            final String modelId = request.getParameter("fdModelId");
            final String modelName = request.getParameter("fdModelName");
            final String key = request.getParameter("fdKey");
            final SysAttMain sysAttMain = this.getSysAttMain(fdId, modelId, modelName, key, true);
            Label_0355: {
                if (sysAttMain != null) {
                    if (StringUtil.isNotNull(sysAttMain.getFdPersonId()) && !sysAttMain.getFdPersonId().equals(UserUtil.getUser().getFdId())) {
                        final Date lastOpenTime = sysAttMain.getFdLastOpenTime();
                        if (lastOpenTime != null) {
                            final Date d = new Date();
                            final long timegap = d.getTime() - lastOpenTime.getTime();
                            if (timegap > 60000L) {
                                isEdit = "1";
                            }
                            else {
                                final SysOrgElement editOrg = this.sysOrgCoreService.findByPrimaryKey(sysAttMain.getFdPersonId());
                                editOrgName = editOrg.getFdName();
                            }
                        }
                    }
                    else {
                        isEdit = "1";
                        final DataSource dataSource = (DataSource)SpringBeanUtil.getBean("dataSource");
                        Connection connect = null;
                        PreparedStatement updateSql = null;
                        try {
                            connect = dataSource.getConnection();
                            connect.setAutoCommit(false);
                            updateSql = connect.prepareStatement("update sys_att_main set fd_person_id=?, fd_last_open_time=? where fd_id=?");
                            updateSql.setString(1, UserUtil.getUser().getFdId());
                            updateSql.setTimestamp(2, new Timestamp(System.currentTimeMillis()));
                            updateSql.setString(3, sysAttMain.getFdId());
                            updateSql.execute();
                            connect.commit();
                        }
                        catch (final SQLException ex) {
                            SysAttJGAddtionIsFirstFunction.logger.error("更新在线编辑时间出错，错误信息：" + ex);
                            if (connect != null) {
                                connect.rollback();
                            }
                            break Label_0355;
                        }
                        finally {
                            JdbcUtils.closeStatement((Statement)updateSql);
                            JdbcUtils.closeConnection(connect);
                        }
                        JdbcUtils.closeStatement((Statement)updateSql);
                        JdbcUtils.closeConnection(connect);
                    }
                }
                else {
                    isEdit = "1";
                }
            }
            final JSONObject json = new JSONObject();
            json.put((Object)"isEdit", (Object)isEdit);
            json.put((Object)"editOrgName", (Object)editOrgName);
            response.setCharacterEncoding("utf-8");
            response.getOutputStream().write(json.toString().getBytes("UTF-8"));
        }
        catch (final Exception e) {
            SysAttJGAddtionIsFirstFunction.logger.error("判断是否只有当前用户在线编辑,出错，错误信息：" + e);
        }
    }
}
